<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/ACL/src/Transport/HTTP2Transport.cpp File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_b1dfedc9efa610ba8c818c30206ff41f.html">ACL</a></li><li class="navelem"><a class="el" href="dir_b7bc15c7de8e43583c698b7747a94971.html">src</a></li><li class="navelem"><a class="el" href="dir_7cc4805d13c57da402acac8e1a9ae866.html">Transport</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#namespaces">Namespaces</a> &#124;
<a href="#define-members">Macros</a> &#124;
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">HTTP2Transport.cpp File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;chrono&gt;</code><br />
<code>#include &lt;functional&gt;</code><br />
<code>#include &lt;random&gt;</code><br />
<code>#include &lt;<a class="el" href="_http_response_code_8h_source.html">AVSCommon/Utils/HTTP/HttpResponseCode.h</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="_h_t_t_p2_mime_request_encoder_8h_source.html">AVSCommon/Utils/HTTP2/HTTP2MimeRequestEncoder.h</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="_h_t_t_p2_mime_response_decoder_8h_source.html">AVSCommon/Utils/HTTP2/HTTP2MimeResponseDecoder.h</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="_logger_8h_source.html">AVSCommon/Utils/Logger/Logger.h</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="_time_utils_8h_source.html">AVSCommon/Utils/Timing/TimeUtils.h</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="_post_connect_interface_8h_source.html">ACL/Transport/PostConnectInterface.h</a>&gt;</code><br />
<code>#include &quot;<a class="el" href="_downchannel_handler_8h_source.html">ACL/Transport/DownchannelHandler.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="_h_t_t_p2_transport_8h_source.html">ACL/Transport/HTTP2Transport.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="_message_request_handler_8h_source.html">ACL/Transport/MessageRequestHandler.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="_ping_handler_8h_source.html">ACL/Transport/PingHandler.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="_transport_defines_8h_source.html">ACL/Transport/TransportDefines.h</a>&quot;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for HTTP2Transport.cpp:</div>
<div class="dyncontent">
<div class="center"><img src="_h_t_t_p2_transport_8cpp__incl.png" border="0" usemap="#_2workplace_2avs-device-sdk_2_a_c_l_2src_2_transport_2_h_t_t_p2_transport_8cpp" alt=""/></div>
<map name="_2workplace_2avs-device-sdk_2_a_c_l_2src_2_transport_2_h_t_t_p2_transport_8cpp" id="_2workplace_2avs-device-sdk_2_a_c_l_2src_2_transport_2_h_t_t_p2_transport_8cpp">
<area shape="rect" id="node5" href="_http_response_code_8h.html" title="AVSCommon/Utils/HTTP\l/HttpResponseCode.h" alt="" coords="1554,105,1724,144"/>
<area shape="rect" id="node9" href="_logger_8h.html" title="AVSCommon/Utils/Logger\l/Logger.h" alt="" coords="1488,279,1664,317"/>
<area shape="rect" id="node20" href="_h_t_t_p2_mime_request_encoder_8h.html" title="AVSCommon/Utils/HTTP2\l/HTTP2MimeRequestEncoder.h" alt="" coords="2086,279,2296,317"/>
<area shape="rect" id="node24" href="_h_t_t_p2_mime_response_decoder_8h.html" title="AVSCommon/Utils/HTTP2\l/HTTP2MimeResponseDecoder.h" alt="" coords="2574,192,2795,231"/>
<area shape="rect" id="node28" href="_time_utils_8h.html" title="AVSCommon/Utils/Timing\l/TimeUtils.h" alt="" coords="5,279,179,317"/>
<area shape="rect" id="node33" href="_post_connect_interface_8h.html" title="ACL/Transport/PostConnect\lInterface.h" alt="" coords="4725,192,4913,231"/>
<area shape="rect" id="node36" href="_downchannel_handler_8h.html" title="ACL/Transport/Downchannel\lHandler.h" alt="" coords="3292,279,3484,317"/>
<area shape="rect" id="node41" href="_h_t_t_p2_transport_8h.html" title="ACL/Transport/HTTP2Transport.h" alt="" coords="3974,199,4195,224"/>
<area shape="rect" id="node48" href="_ping_handler_8h.html" title="ACL/Transport/PingHandler.h" alt="" coords="2968,285,3163,311"/>
<area shape="rect" id="node49" href="_message_request_handler_8h.html" title="ACL/Transport/MessageRequest\lHandler.h" alt="" coords="3509,279,3724,317"/>
<area shape="rect" id="node50" href="_transport_defines_8h.html" title="ACL/Transport/TransportDefines.h" alt="" coords="1963,112,2187,137"/>
<area shape="rect" id="node8" href="_logger_utils_8h.html" title="AVSCommon/Utils/Logger\l/LoggerUtils.h" alt="" coords="1488,192,1664,231"/>
<area shape="rect" id="node14" href="_configuration_node_8h.html" title="AVSCommon/Utils/Configuration\l/ConfigurationNode.h" alt="" coords="989,365,1203,404"/>
<area shape="rect" id="node16" href="_level_8h.html" title="AVSCommon/Utils/Logger\l/Level.h" alt="" coords="1526,452,1702,491"/>
<area shape="rect" id="node17" href="_log_entry_8h.html" title="AVSCommon/Utils/Logger\l/LogEntry.h" alt="" coords="1278,365,1454,404"/>
<area shape="rect" id="node18" href="_log_level_observer_interface_8h.html" title="AVSCommon/Utils/Logger\l/LogLevelObserverInterface.h" alt="" coords="1478,365,1675,404"/>
<area shape="rect" id="node19" href="_sink_observer_interface_8h.html" title="AVSCommon/Utils/Logger\l/SinkObserverInterface.h" alt="" coords="1851,365,2027,404"/>
<area shape="rect" id="node22" href="_h_t_t_p2_mime_request_source_interface_8h.html" title="AVSCommon/Utils/HTTP2\l/HTTP2MimeRequestSourceInterface.h" alt="" coords="3245,365,3500,404"/>
<area shape="rect" id="node23" href="_h_t_t_p2_request_source_interface_8h.html" title="AVSCommon/Utils/HTTP2\l/HTTP2RequestSourceInterface.h" alt="" coords="2672,365,2894,404"/>
<area shape="rect" id="node26" href="_h_t_t_p2_mime_response_sink_interface_8h.html" title="AVSCommon/Utils/HTTP2\l/HTTP2MimeResponseSinkInterface.h" alt="" coords="2560,279,2809,317"/>
<area shape="rect" id="node27" href="_h_t_t_p2_response_sink_interface_8h.html" title="AVSCommon/Utils/HTTP2\l/HTTP2ResponseSinkInterface.h" alt="" coords="2432,365,2648,404"/>
<area shape="rect" id="node31" href="_retry_timer_8h.html" title="AVSCommon/Utils/RetryTimer.h" alt="" coords="603,372,813,397"/>
<area shape="rect" id="node32" href="_safe_c_time_access_8h.html" title="AVSCommon/Utils/Timing\l/SafeCTimeAccess.h" alt="" coords="304,365,478,404"/>
<area shape="rect" id="node34" href="_post_connect_observer_interface_8h.html" title="ACL/Transport/PostConnect\lObserverInterface.h" alt="" coords="4832,279,5019,317"/>
<area shape="rect" id="node35" href="_post_connect_send_message_interface_8h.html" title="ACL/Transport/PostConnect\lSendMessageInterface.h" alt="" coords="4620,279,4807,317"/>
<area shape="rect" id="node37" href="_attachment_manager_8h.html" title="AVSCommon/AVS/Attachment\l/AttachmentManager.h" alt="" coords="3019,365,3221,404"/>
<area shape="rect" id="node38" href="_exchange_handler_8h.html" title="ACL/Transport/ExchangeHandler.h" alt="" coords="3524,372,3751,397"/>
<area shape="rect" id="node39" href="_message_consumer_interface_8h.html" title="ACL/Transport/MessageConsumer\lInterface.h" alt="" coords="4103,365,4330,404"/>
<area shape="rect" id="node40" href="_mime_response_status_handler_interface_8h.html" title="ACL/Transport/MimeResponse\lStatusHandlerInterface.h" alt="" coords="3825,365,4029,404"/>
<area shape="rect" id="node46" href="_h_t_t_p2_connection_interface_8h.html" title="AVSCommon/Utils/HTTP2\l/HTTP2ConnectionInterface.h" alt="" coords="3799,279,3997,317"/>
<area shape="rect" id="node47" href="_auth_delegate_interface_8h.html" title="AVSCommon/SDKInterfaces\l/AuthDelegateInterface.h" alt="" coords="4456,365,4646,404"/>
</map>
</div>
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="namespaces"></a>
Namespaces</h2></td></tr>
<tr class="memitem:namespacealexa_client_s_d_k"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></td></tr>
<tr class="memdesc:namespacealexa_client_s_d_k"><td class="mdescLeft">&#160;</td><td class="mdescRight">Whether or not curl logs should be emitted. <br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:namespacealexa_client_s_d_k_1_1acl"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1acl.html">alexaClientSDK::acl</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:ad8bc9ca8e55a0ebf538e46e28bf26262"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_h_t_t_p2_transport_8cpp.html#ad8bc9ca8e55a0ebf538e46e28bf26262">LX</a>(event)&#160;&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">alexaClientSDK::avsCommon::utils::logger::LogEntry</a>(<a class="el" href="_u_i_manager_8cpp.html#ada5473a95becdcf63a8f83e7f05fefe7">TAG</a>, event)</td></tr>
<tr class="separator:ad8bc9ca8e55a0ebf538e46e28bf26262"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a3af97973c2d1e0bcc9a0f89aeea1e29e"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1acl.html#a3af97973c2d1e0bcc9a0f89aeea1e29e">alexaClientSDK::acl::TAG</a> (&quot;HTTP2Transport&quot;)</td></tr>
<tr class="memdesc:a3af97973c2d1e0bcc9a0f89aeea1e29e"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="namespacealexa_client_s_d_k_1_1acl.html#a3af97973c2d1e0bcc9a0f89aeea1e29e">More...</a><br /></td></tr>
<tr class="separator:a3af97973c2d1e0bcc9a0f89aeea1e29e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2fa363fbf0864cee86273f59ecc4ea8e"><td class="memItemLeft" align="right" valign="top">std::ostream &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1acl.html#a2fa363fbf0864cee86273f59ecc4ea8e">alexaClientSDK::acl::operator&lt;&lt;</a> (std::ostream &amp;stream, HTTP2Transport::State state)</td></tr>
<tr class="separator:a2fa363fbf0864cee86273f59ecc4ea8e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:aae074297f1503086d4dc59e86ca58743"><td class="memItemLeft" align="right" valign="top">static const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1acl.html#aae074297f1503086d4dc59e86ca58743">alexaClientSDK::acl::MAX_STREAMS</a> = 10</td></tr>
<tr class="separator:aae074297f1503086d4dc59e86ca58743"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ade5efa26d0ffcb62e2577df7a79e5992"><td class="memItemLeft" align="right" valign="top">static const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1acl.html#ade5efa26d0ffcb62e2577df7a79e5992">alexaClientSDK::acl::MAX_MESSAGE_HANDLERS</a> = MAX_STREAMS - 2</td></tr>
<tr class="memdesc:ade5efa26d0ffcb62e2577df7a79e5992"><td class="mdescLeft">&#160;</td><td class="mdescRight">Max number of message requests MAX_STREAMS - 2 (for the downchannel stream and the ping stream)  <a href="namespacealexa_client_s_d_k_1_1acl.html#ade5efa26d0ffcb62e2577df7a79e5992">More...</a><br /></td></tr>
<tr class="separator:ade5efa26d0ffcb62e2577df7a79e5992"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7a6592c43f3fe5f0703fec4f906dde09"><td class="memItemLeft" align="right" valign="top">static std::chrono::minutes&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1acl.html#a7a6592c43f3fe5f0703fec4f906dde09">alexaClientSDK::acl::INACTIVITY_TIMEOUT</a> {5}</td></tr>
<tr class="memdesc:a7a6592c43f3fe5f0703fec4f906dde09"><td class="mdescLeft">&#160;</td><td class="mdescRight">Timeout to send a ping to AVS if there has not been any other acitivity on the connection.  <a href="namespacealexa_client_s_d_k_1_1acl.html#a7a6592c43f3fe5f0703fec4f906dde09">More...</a><br /></td></tr>
<tr class="separator:a7a6592c43f3fe5f0703fec4f906dde09"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Macro Definition Documentation</h2>
<a id="ad8bc9ca8e55a0ebf538e46e28bf26262"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad8bc9ca8e55a0ebf538e46e28bf26262">&#9670;&nbsp;</a></span>LX</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define LX</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">event</td><td>)</td>
          <td>&#160;&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">alexaClientSDK::avsCommon::utils::logger::LogEntry</a>(<a class="el" href="_u_i_manager_8cpp.html#ada5473a95becdcf63a8f83e7f05fefe7">TAG</a>, event)</td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Create a LogEntry using this file's TAG and the specified event string.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">The</td><td>event string for this <code>LogEntry</code>. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
